#include <bits/stdc++.h>+
#define all(x) (x).begin(),(x).end()
#define ll long long
using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, m;
    cin>>n>>m;
    if(n==1){
        ll a, b;
        cin>>a>>b;
        vector<ll> c(m), d(m);
        for(int i=0; i<m; i++) cin>>c[i]>>d[i];
        vector<ll> v(m, 0);
        for(int i=0; i<m; i++) v[i]=c[i];
        ll suma=accumulate(all(v), 0ll);
        for(int i=0; i<m; i++){
            if(suma+d[i]-c[i]<=b){
                v[i]=d[i];
                suma=suma+d[i]-c[i];
            }
            else{
                v[i]=v[i]+b-suma;
                break;
            }
        }
        cout<<suma<<'\n';
        ll k=0;
        for(int i=0; i<m; i++){
            if(v[i]) k++;
        }
        cout<<k<<'\n';
        for(int i=0; i<m; i++){
               // cout<<v[i]<<' ';
            if(v[i]){
                cout<<"1 "<<i+1<<' '<<v[i]<<'\n';
            }
        }
    }
    return 0;
}